#include "../Chani.h"
#include "../globalConsts.h"
#include "../classes/Findij.h" 

void addCharge(double x, double y, double q, int tStep){
	
	//File name:
	TString fnameh = TString::Format("%sh.root", dir);

	Findij fij(x,y);
	int i = fij.Geti();
	int j = fij.Getj();
	int nx = fij.Getnx();
	int ny = fij.Getny();
	double ax = fij.Getax();
	double ay = fij.Getay();
	double sigmaadd = q/(ax*ay); // additional surface charge density
		
	TFile f(fnameh, "UPDATE"); // open the output file for histograms
	//f.GetListOfKeys()->Print(); // Print to see if the objects are retrieved properly
	
	TH2 *sigmah; // The temporary surface charge density histogram
	
	char objName[16];
	sprintf(objName, "sigmah%i", tStep); 
	
	f.GetObject(objName, sigmah);
	
	sigmah->SetCellContent(i, j, sigmah->GetCellContent(i,j)+sigmaadd);
	
	sigmah->Write(objName); // Write the histogram back
	
	f.Close();
	
}
