#include "../Chani.h"
#include "../globalConsts.h"
#include "../classes/Readp.h"

void computelmn(){

	Readp rp;
	double lx = rp.Getlx();
	double ly = rp.Getly();
	double ax = rp.Getax();
	double ay = rp.Getay();
	int nx = rp.Getnx();
	int ny = rp.Getny();
	int Nm = rp.GetNm();

	int N = nx*ny;

	TString fnamev = TString::Format("%sxy.root", dir);

	// Reading of x & y vectors:	
	TFile f(fnamev); 
		
	TVectorD *xp; // Pointer for x-vector
	f.GetObject("x-vector",xp);
	TVectorD x(1,N);
	x = *xp;
	delete xp;

	TVectorD *yp; // Pointer for y-vector
	f.GetObject("y-vector",yp);
	TVectorD y(1,N);
	y = *yp;
	delete yp;
	
	f.Close();
		
	double DeltaSn = ax*ay; //Area of a subsection

	std::cout << "Area of a subsection DeltaSn (m^2) = " << DeltaSn << std::endl;

	std::cout << "Calculation of the l(m,n) matrix ..." << std::endl;

	int nsub = N / Nm;
	TMatrixD lsub(1,nsub,1,nsub);

	for (int i = 1; i <= Nm; i++){
		for (int j = 1; j<= Nm; j++){
		
			TString fname = TString::Format("%slmatrix%i.root",dir, i+(j-1)*Nm);
		
			TFile f(fname,"recreate"); // open the output file. 

			for (int m = (j-1)*nsub+1; m <= j*nsub; m++){
				for (int n = (i-1)*nsub+1; n<= i*nsub; n++){
				
					int mm = m - (j-1)*nsub;
					int nm = n - (i-1)*nsub;

					if (n == m){
						lsub(mm,nm) = (1/(4*pi*epsilon0))
									*(ax*log((sqrt(pow(ay,2) + pow(ax,2)) + ay)/(sqrt(pow(ay,2) + pow(ax,2)) - ay)) 
									+ ay*log((sqrt(pow(ax,2) + pow(ay,2)) + ax)/(sqrt(pow(ax,2) + pow(ay,2)) - ax)));
								}		
					else{
						lsub(mm,nm) = DeltaSn/(4*pi*epsilon0*sqrt(pow((x(m)-x(n)),2)+pow((y(m)-y(n)),2))) ;
						}		
					
					//std::cout << "l(" << m << ", " << n << ") = " << lsub(mm,nm) << " ";
				}
			}

			char label[12];
			sprintf(label, "l-matrix%i", i+(j-1)*Nm);
			lsub.Write(label);
			f.Close(); // Close the output file
	}
}
	
}
