#include "../Chani.h"
#include "../classes/Readp.h"

double getQtotal(int tStep){
	
	Readp rp;
	double ax = rp.Getax();
	double ay = rp.Getay();
	double nx = rp.Getnx();
	double ny = rp.Getny();
	
	double sum = 0;
	
	TString fnameh = TString::Format("%sh.root", dir);

	TFile f(fnameh); // open the output file for histograms
	
	TH2 *sigmah; // Surface charge density histogram

	char objName[16];
	sprintf(objName, "sigmah%i", tStep); 
	f.GetObject(objName, sigmah); // read the surface charge distribution at time = Deltat * tStep
	
	for (int j = 1; j<=ny; j++){ 
		for (int i = 1; i<=nx; i++){	
			sum = sum + sigmah->GetCellContent(i,j);
		}
	}
	
	delete sigmah;
	
	sum = sum * ax * ay; //from charge density to total charge
	
	f.Close();
	
	return sum;
	
}
