#include "../Chani.h"
#include "../globalConsts.h"

void parameters(double lx, int nx, double ly, int ny, int Nm, double sigmas) {

	
	TString fnameg = TString::Format("%sparameters.root", dir);
	
	TString fnamev = TString::Format("%sxy.root", dir);
	
	TString fnameh = TString::Format("%sh.root", dir);
	
	double ax = lx/nx; // unit length in x
	double ay = ly/ny; // unit length in y
		
	int N = nx*ny;
	std::cout << "The total number of subsections is N = " << N << std::endl;

	std::cout << "The l-matrix is going to be calculated in "; 
	std::cout << Nm*Nm << " parts." << std::endl;


	// Assigning the x & y coordinates to the subsections

	TVectorD x(1,N);
	TVectorD y(1,N);

	if (nx%2 == 0 && ny%2 == 0){
	  for (int j = 1; j < ny+1; j++){
	    for (int i=1; i < nx+1; i++){
	      
	      x(i+nx*(j-1)) = -ax*(nx/2) + ax/2 + (i-1)*ax;
	      y(i+nx*(j-1)) = -ay*(ny/2) + ay/2 + (j-1)*ay;
	      
	    }
	  }
	}

	else if (nx%2 == 1 && ny%2 == 1){
	  for (int j = 1; j < ny+1; j++){
	    for (int i=1; i < nx+1; i++){

	      x(i+nx*(j-1)) = -ax*((nx-1)/2) + (i-1)*ax;
	      y(i+nx*(j-1)) = -ay*((ny-1)/2) + (j-1)*ay;

	    }
	  }
	}

	else {
	  std::cout << "number of subsections for x and y should be both even or both odd." << std::endl;
	  return;
	}

	TH2 *sigmah0;
	sigmah0 = new TH2D("sigma0(x,y)", "Surface charge density at t = 0", nx, -lx/2, lx/2, ny, -ly/2, ly/2) ;
	
	TH2 *connh;
	connh = new TH2D("conn(x,y)", "Connectors histogram", nx, -lx/2, lx/2, ny, -ly/2, ly/2) ;
	
	for (int j = 1; j < ny+1; j++){
		for (int i=1; i < nx+1; i++){
		
			connh->SetCellContent(i, j, 1e20); // Assign a nonzero dummy value to the histogram contents
			
		}
	}


	TFile f(fnameg,"recreate"); // open the output file. 

	TH1 *params; // The histogram to hold lx, nx, ax, ly, ny, ay, Nm values in
	params = new TH1D("params","lx, nx, ax, ly, ny, ay, Nm",8,1,8);
	
	params->SetBinContent(1, lx);
	params->SetBinContent(2, nx);
	params->SetBinContent(3, ax);
	params->SetBinContent(4, ly);
	params->SetBinContent(5, ny);
	params->SetBinContent(6, ay);
	params->SetBinContent(7, Nm);
	params->SetBinContent(8, sigmas);

	params->Write(); // Write params histogram in file

	delete params;

	f.Close(); // Close the output file

	TFile f2(fnamev,"recreate"); // open the output file for x & y. 

	x.Write("x-vector"); // Write x coordinates in the file
	y.Write("y-vector"); // Write y coordinates in the file
	
	f2.Close();
	
	TFile f3(fnameh,"recreate"); // open the output file for histograms

	sigmah0->Write("sigmah0"); // Blank histogram of the surface
	connh->Write("connh"); // Connector histogram of the surface
	
	f3.Close();

	delete connh;
	delete sigmah0;

}
