#include "../Chani.h"
#include "../classes/Readp.h"
#include "getV.C"

void transient1(int tStepi, int nofSteps, double Deltat){
	
	Readp rp;
	double lx = rp.Getlx();
	double ly = rp.Getly();
	double ax = rp.Getax();
	double ay = rp.Getay();
	int nx = rp.Getnx();
	int ny = rp.Getny();
	int Nm = rp.GetNm();
	double sigmas = rp.Getsigmas();	
	
	int N = nx*ny; // number of sub-cells
	int nsub = N / Nm; // dimension of the sub matrices
	int Nl = Nm * Nm; // number of l-matrices
	
	double DeltaSn = ax*ay; // unit area
	
	//Create and write Vi & sigmai vectors:
	
	for (int i = 1; i <= Nm; i++){
		
		TVectorD V(1,nsub);
		TVectorD sigma(1,nsub);

		TString fname = TString::Format("%sVsigma%i", dir, i);
				
		TFile f(fname, "recreate"); // open the output file
		
		char labelV[5];
		char labelsigma[10];
		
		sprintf(labelV, "V%i", i);
		V.Write(labelV);
		
		sprintf(labelsigma, "sigma%i", i);		
		sigma.Write(labelsigma);
		
		f.Close();
	}
	
	//Read the initial surface charge density and connector histogram:	
	
	TH2 *sigmaht; // Surface charge density histogram
	sigmaht = new TH2D("SigmahtStep(x,y)", "Surface charge density" , nx, -lx/2, lx/2, ny, -ly/2, ly/2) ;
	
	TH2 *connh; //The connector histogram:
	connh = new TH2D("Connectors", "Connector histogram" , nx, -lx/2, lx/2, ny, -ly/2, ly/2) ;
	
	TString fnameh = TString::Format("%sh.root", dir);

	TFile f(fnameh); // open the output file for histograms
	
	char objName[16];
	sprintf(objName, "sigmah%i", tStepi); 
	
	TH2 *sigmahtd;
	TH2 *connhd;
			
	f.GetObject(objName, sigmahtd); // Read the initial surface charge density histogram
	f.GetObject("connh", connhd); // Read the connector histogram
	
	for (int j = 1; j<=ny; j++){ 
		for (int i = 1; i<=nx; i++){	
			sigmaht->SetCellContent(i, j, sigmahtd->GetCellContent(i,j));
		}
	}

	for (int j = 1; j<=ny; j++){ 
		for (int i = 1; i<=nx; i++){	
			connh->SetCellContent(i, j, connhd->GetCellContent(i,j));
		}
	}
	
	delete sigmahtd;
	delete connhd;
	
	f.Close();
	
	//Write the initial surface charge density histogram to the sigma vectors:
	
	int dummy;
	
	for (int isigma = 1; isigma <= Nm; isigma++){
	
	TString fname = TString::Format("%sVsigma%i", dir, isigma);
	
	TFile f2(fname, "UPDATE"); // open the output file
	//f.GetListOfKeys()->Print();
	
	char labelsigma[10];
	sprintf(labelsigma, "sigma%i", isigma);			
	
	TVectorD * sigmav;
	f2.GetObject(labelsigma, sigmav);
		
		for (int j = 1; j <= ny; j++){
			for (int i = 1; i <= nx; i++){
				
				dummy = ((j-1)*nx+i - 1)/nsub + 1;
				
				if (dummy == isigma){
				  //std::cout << "cell (" << i << ", " << j << ") belongs to the vector "<< isigma << std::endl;
				  (*sigmav)((j-1)*nx+i - (isigma-1)*nsub) = sigmaht->GetCellContent(i, j);
					
				}
				
			}	
		}		
		
	sigmav->Write(labelsigma);	
	delete sigmav;
	f2.Close();	
		
	}
	
	double Kt, It, Rcon; //Surface current density, Discharge current
	TVectorD Vi(1,nsub); // i-th V vector
	TVectorD sigmavj(1,nsub); // j-th sigma vector
	TMatrixD lj(1,nsub,1,nsub); // [(i-1)*Nm+j]-th l-matrix
				
	//Transient loop:
	
	for (int it = tStepi + 1; it <= tStepi + nofSteps; it++){
		
		std::cout << "Time step " << it << std::endl;
	
		//Calculation of the new potential:
	
		for (int i = 1; i<=Nm; i++){
			
			Vi.Zero();
			
			for (int j = 1; j<=Nm; j++){
	
				//std::cout << "i, j = " << i << ", " << j << std::endl;
				
				TString fname = TString::Format("%sVsigma%i", dir, j);
					
				TFile f1(fname); // open the output file of vectors
				
				TVectorD *sigmavp; // pointer for the sigma-vector			

				char labelsigma[10];
				sprintf(labelsigma, "sigma%i", j);		
				f1.GetObject(labelsigma, sigmavp);
				sigmavj = *sigmavp;
			
				delete sigmavp;
			
				f1.Close();
				
				//sigmavp->~sigmavp();				
				//delete sigmavp;

				TString fnamel = TString::Format("%slmatrix%i.root",dir, (i-1)*Nm+j);

				TMatrixD *ljp; // pointer for the (i-1)Nm+jth l-matrix					
					
				TFile f(fnamel); // open the output file of l(i-1)Nm+j

				//f.GetListOfKeys()->Print(); // 
					
					char label[10];
					sprintf(label, "l-matrix%i", (i-1)*Nm+j);					
					f.GetObject(label, ljp);
					//*/
				f.Close();
				
				lj = *ljp;
				delete ljp;
				
				Vi = Vi + lj * sigmavj;

			}

			//std::cout << " Vi(38) = " << Vi(38) << std::endl; 

			TString fname = TString::Format("%sVsigma%i", dir, i);

			TFile f(fname, "UPDATE"); // open the output file
		
			char labelV[5];
			sprintf(labelV, "V%i", i);
			
			Vi.Write(labelV);	
			
			f.Close();

		}
		
		//Update the surface charge density histogram due to the currents:
		// Handling the currents in x:

		for (int j = 1; j<=ny; j++){
			for (int i = 1; i<=nx-1; i++){	
		
				Kt = ((-1)*(getV(i+1+nx*(j-1)) - getV(i+nx*(j-1)))*sigmas)/ax;
				sigmaht->SetCellContent(i, j, sigmaht->GetCellContent(i,j) - (Kt*Deltat*ay)/DeltaSn);			
				sigmaht->SetCellContent(i+1, j, sigmaht->GetCellContent(i+1,j) + (Kt*Deltat*ay)/DeltaSn);	
		
			}
		}

		// Handling the currents in y:
		for (int j = 1; j<=ny-1; j++){
			for (int i = 1; i<=nx; i++){	
		
				Kt = ((-1)*(getV(i+nx*j) - getV(i+nx*(j-1)))*sigmas)/ay;
				sigmaht->SetCellContent(i, j, sigmaht->GetCellContent(i,j) - (Kt*Deltat*ax)/DeltaSn);			
				sigmaht->SetCellContent(i, j+1, sigmaht->GetCellContent(i,j+1) + (Kt*Deltat*ax)/DeltaSn);	
		
			}
		}
		//*/

		//Discharge currents:
		for (int j = 1; j<=ny; j++){
			for (int i = 1; i<=nx; i++){	
			
				if(connh->GetCellContent(i,j) < 1e20) {
					
					Rcon = (1/(2*sigmas)) + connh->GetCellContent(i,j);
					It = ((-1)*(getV(1+nx*(j-1)) - 0)) / Rcon;
					
					sigmaht->SetCellContent(i, j, sigmaht->GetCellContent(i,j) + (It*Deltat)/DeltaSn);		
					
					//std::cout << "It = " << It << std::endl;
					
				}
		
			}
		}

		//Update sigmavt:	
		for (int isigma = 1; isigma <= Nm; isigma++){

		TString fname = TString::Format("%sVsigma%i", dir, isigma);
	
		TFile f(fname, "UPDATE"); // open the output file
	
		char labelsigma[10];
		sprintf(labelsigma, "sigma%i", isigma);			

		TVectorD * sigmav;
		f.GetObject(labelsigma, sigmav);

			for (int j = 1; j <= ny; j++){
				for (int i = 1; i <= nx; i++){
				
				  dummy = ((j-1)*nx+i - 1)/nsub + 1;
				
				  if (dummy == isigma){
					
				    (*sigmav)((j-1)*nx+i - (isigma-1)*nsub) = sigmaht->GetCellContent(i, j);
					
				  }
				}	
			}		

		sigmav->Write(labelsigma);	
		f.Close();	
		
		}
		
	}

	TFile f3(fnameh, "UPDATE"); // open the output file for histograms
	
	char sigmahfName[16];
	sprintf(sigmahfName, "sigmah%i", tStepi+nofSteps); 
	TH2 *sigmahf; // Final surface charge density histogram

	sigmahf = new TH2D(Form("Sigmah%i(x,y)",tStepi+nofSteps), "Surface charge density", nx, -lx/2, lx/2, ny, -ly/2, ly/2) ;

	//Fill the final surface charge density histogram:	
	for (int j = 1; j<=ny; j++){ 
			for (int i = 1; i<=nx; i++){	
				sigmahf->SetCellContent(i, j, sigmaht->GetCellContent(i,j));
			}
		}

	sigmahf->Write(sigmahfName); // Write the histogram after transient calculation

	delete sigmahf;
	
	f3.Close();	
	
	delete sigmaht;
	delete connh;
		
}
