#include <iostream>
#include "Chani.h"
#include "TH1.h"
#include "TH2.h"
#include "TCanvas.h"
#include "TMath.h"
#include <cmath>
#include "TFile.h"

void getresults(){

Readp rp;
double lx = rp.Getlx();
double ly = rp.Getly();
double ax = rp.Getax();
double ay = rp.Getay();
int nx = rp.Getnx();
int ny = rp.Getny();

cout << " ax = " << ax << endl;

const unsigned int nSteps = 6;
int tStep[nSteps] = {0, 10, 50, 100, 200, 1000}; 

TH2 *sigmahd[nSteps]; // Surface charge density histogram for drawing		
for (unsigned int ih=0; ih<nSteps; ++ih) {
  sigmahd[ih] = new TH2D(TString::Format("Sigmah%ixy",tStep[ih]), TString::Format("Surface charge density at t=%i ns",tStep[ih] / 10), nx, -lx/2, lx/2, ny, -ly/2, ly/2) ; }

TString fnameh(TString(dir)+"h.root");
TFile f(fnameh); // open the output file for histograms
//f.GetListOfKeys()->Print(); // Print to see if the objects are retrieved properly

TH2 *sigmah[nSteps]; // Surface charge density histograms

//Fill the surface charge density histograms:	
for (unsigned int ih=0; ih<nSteps; ++ih) {
  TString objName = TString::Format("sigmah%i",tStep[ih]);
  f.GetObject(objName, sigmah[ih]); // read the surface charge distribution at time = Deltat * tStep
  if ( sigmah[ih] == 0 ) continue; // if histo not found
  for (int j = 1; j<=ny; j++){ 
    for (int i = 1; i<=nx; i++){	
      sigmahd[ih]->SetCellContent(i, j, sigmah[ih]->GetCellContent(i,j));
    }
  }
}

f.Close();

TCanvas *c1 = new TCanvas("c1","c1",1000,800);
if ( nSteps == 6 ) c1->Divide(2,3);
else c1->Divide( nSteps );
gStyle->SetNumberContours(999); // increase number of contour colors for smoother transitions, unfortunately the color pallette from ROOT really supports only 99 colors

// Define our own color pallette which really supports 999 colors
// This palette has white as the minimum value, so very small non-zero values
//  also appear as white - not as purple
// Taken from http://hep.uchicago.edu/~strait/rootcolors
const int NRGBs = 7, NCont = 999;
gStyle->SetNumberContours(NCont);
Double_t stops[NRGBs] = { 0.00, 0.10, 0.25, 0.45, 0.60, 0.75, 1.00 };
Double_t red[NRGBs]   = { 1.00, 0.00, 0.00, 0.00, 0.97, 0.97, 0.10 };
Double_t green[NRGBs] = { 1.00, 0.97, 0.30, 0.40, 0.97, 0.00, 0.00 };
Double_t blue[NRGBs]  = { 1.00, 0.97, 0.97, 0.00, 0.00, 0.00, 0.00 };
TColor::CreateGradientColorTable(NRGBs, stops, red, green, blue, NCont); // comment 1

for (unsigned int ih=0; ih<nSteps; ++ih) {
  c1->cd(ih+1);
  sigmahd[ih]->SetMaximum(1.2e-10); // comment 2
  gPad->SetLogz(); // comment 3
  sigmahd[ih]->SetStats(0);
  sigmahd[ih]->Draw("colz");
}

c1->cd();

}
