#include <iostream>
#include "Chani.h"
#include "TH1"
#include "TH2"

void initialcharge(){

Readp rp;
double lx = rp.Getlx();
double ly = rp.Getly();
double ax = rp.Getax();
double ay = rp.Getay();
int nx = rp.Getnx();
int ny = rp.Getny();
int Nm = rp.GetNm();

int N = nx*ny;
double DeltaSn = ax*ay;

double qadd = (1e4*1.6e-19); //add 1e4 elementary charge
//5 areas due to the 2d gaussian probabilities:
double a0 = (1 - ROOT::Math::normal_cdf(-ax/2, ax, 0)*2)*(1 - ROOT::Math::normal_cdf(-ay/2, ay, 0)*2);
double a1 = ROOT::Math::normal_cdf_c(ax/2,ax,0)*(1 - ROOT::Math::normal_cdf(-ay/2, ay, 0)*2);
double a2 = ROOT::Math::normal_cdf_c(ax/2,ax,0)*ROOT::Math::normal_cdf_c(ay/2,ay,0);
double a3 = ROOT::Math::normal_cdf_c(ay/2,ay,0)*(1 - ROOT::Math::normal_cdf(-ax/2, ax, 0)*2);

//Add the initial charge with the gaussian probabilities:
addCharge(0, 0, qadd*a0, 0); // C
addCharge(ax, 0, qadd*a1, 0); // R
addCharge(ax, ay, qadd*a2, 0); // UR
addCharge(0, ay, qadd*a3, 0); // U
addCharge(-ax, ay, qadd*a2, 0); // UL
addCharge(-ax, 0, qadd*a1, 0); // L
addCharge(-ax, -ay, qadd*a2, 0); // DL
addCharge(0, -ay, qadd*a3, 0); // D
addCharge(ax, -ay, qadd*a2, 0); // UR

}
