#include <iostream>
#include "Chani.h"
#include "TH1"
#include "TH2"
#include "TCanvas"
#include "TMath"
#include "TMatrixD"
#include "TVectorD"
#include "math.h"
#include "TFile.h"
#include "classes/Readp.h"

void qxy(){

	int tStepi = 0; // first time step
	int tStepf = 600; // final time step
	double Deltat = 1e-11; // duration of time steps
	int DeltatStep = 10; // histograms corresponding to 0, DeltatStep, 2*DeltatStep, 3*DeltatStep... instances are recorded
	int nBinTotal = (tStepf-tStepi)/DeltatStep + 1; //total number of bins

	double ti = tStepi*Deltat;
	double tf = tStepf*Deltat;

	double x = 0;
	double y = 0;

	TH1 *qxy;
	qxy = new TH1D("Q vs t","Charge at (0,0) versus time",nBinTotal, ti*1e9, tf*1e9);

	double q;

	for (int it = tStepi; it <= tStepf; it += DeltatStep){
	
		q = getQxy(x,y,it-tStepi);
		//std::cout << "q at time step " << it << " is " << q << std::endl;
		qxy->SetBinContent(it/DeltatStep+1, q);		
			
	}

	qxy->SetStats(0);
	qxy->SetXTitle("Time (ns)");
	qxy->SetYTitle("Charge (Coulomb)");
	
	TCanvas *c1 = new TCanvas("c1","c1",600,400);
	
	qxy->Draw();
	qxy->Fit("expo");

	TF1 *fit = qxy->GetFunction("expo");

	//fit->SetParameter(0, log(qxy->GetBinContent(tStepi)));
		
	//c1->Update();
		
	double tau ;

	tau = (-1)/(fit->GetParameter(1));

	std::cout << "tau = " << tau << std::endl;

}
