#include <iostream>
#include "Chani.h"
#include "TH1.h"
#include "TH2.h"
#include "TCanvas"
#include "TMath"
#include "TMatrixD"
#include "TVectorD"
#include "math.h"
#include "TFile"

void totalcharge(){

Readp rp;
double ax = rp.Getax();
double ay = rp.Getay();
int nx = rp.Getnx();
int ny = rp.Getny();


TFile f(TString::Format("%s/h.root",dir)); // open the output file for histograms
int noOfBrowsables = f.GetListOfKeys()->GetEntries();
int sstr = -1, send = -1, dels = 1; // starting & ending steps & delta step
for (int k=0; k<noOfBrowsables; k++) {
  TString objname = f.GetListOfKeys()->At(k)->GetName();
  if ( !objname.BeginsWith("sigmah") ) continue;
  TObject *myobj = gROOT->FindObject(objname);
  if ( myobj == 0 || !myobj->InheritsFrom("TH1") ) continue;
  objname.Remove(0,6); // removing the string sigmah
  int val = atoi(objname.Data());
  //cout << val << endl;
  if ( val<0 ) {
    cout << "Something is really broken here!" << endl; continue; }
  if ( sstr == -1 ) {  // the first value read
    sstr = val; send = val; continue; }
  if ( send == sstr ) {  // the second value read
    send = val; dels = send - sstr; continue; }
  if ( send + dels != val ) {  // any new value should be previous send + dels
    cout << "Time steps are not ordered properly in the TFile. Sorry!" << endl;
    break; }
  send = val;
}
cout << "Parsing the file, we find histograms for time steps from " << sstr
     << " to " << send << " with deltatStep =" << dels << endl;

//Total charge histogram:
gDirectory->cd("Rint:/"); // create histogram not in the file - if we don't do this, histogram is lost when the file is closed.
double Deltat = 1e-4; // duration of time steps in microseconds!
int nBinTotal = (send-sstr)/dels + 1; //total number of bins
TH1D *totalcharge = new TH1D("Q vs t","Total charge versus time",
			     nBinTotal, sstr*Deltat, send*Deltat);


for (int it = sstr; it <= send; it += dels){

	TH2 *sigmah; // Surface charge density histogram

	f.GetObject(TString::Format("sigmah%i",it), sigmah); // read the surface charge distribution at time = Deltat * tStep
        if ( sigmah==0 ) break;  // stop as soon as we are unable to find a given histo - should not happen, but just in case.

	double sum = sigmah->GetSumOfWeights() * ax * ay; //from surface charge density to total charge

	totalcharge->SetBinContent(it/dels+1, sum);

	delete sigmah;

}
f.Close();

totalcharge->SetStats(0);
totalcharge->SetXTitle("Time (#mus)");
totalcharge->SetYTitle("Charge (Coulomb)");
totalcharge->Draw();
//totalcharge->Fit("expo");
}
