#include <iostream>
#include "Chani.h"
#include "TH1"
#include "TH2"
#include "TCanvas"
#include "TMath"
#include "TMatrixD"
#include "TVectorD"
#include "math.h"
#include "TFile"

void totalchargeold(){

Readp rp;
double lx = rp.Getlx();
double ly = rp.Getly();
double ax = rp.Getax();
double ay = rp.Getay();
int nx = rp.Getnx();
int ny = rp.Getny();
int Nm = rp.GetNm();

//Total charge histogram:


int tStepi = 0; // first time step
int tStepf = 100000; // final time step
double Deltat = 1e-10; // duration of time steps
int DeltatStep = 100; // histograms corresponding to 0, DeltatStep, 2*DeltatStep, 3*DeltatStep... instances are recorded
int nBinTotal = (tStepf-tStepi)/DeltatStep + 1; //total number of bins

double ti = tStepi*Deltat;
double tf = tStepf*Deltat;

TH1 *totalcharge;
totalcharge = new TH1D("Q vs t","Total charge versus time",nBinTotal, ti, tf);

char fnameh[100];

sprintf(fnameh, "%sh.root", dir);		

TFile f(fnameh); // open the output file for histograms

f.GetListOfKeys()->Print(); // Print to see if the objects are retrieved properly

for (int it = 0; it <= tStepf; it += DeltatStep){

	TH2 *sigmah; // Surface charge density histogram
	
	char objName[16];
	

	sprintf(objName, "sigmah%i", it); 
	f.GetObject(objName, sigmah); // read the surface charge distribution at time = Deltat * tStep

	double sum = 0;

	for (int j = 1; j<=ny; j++){ 
		for (int i = 1; i<=nx; i++){	
			sum = sum + sigmah->GetCellContent(i,j);
		}
	}
	
	sum = sum * ax * ay; //from surface charge density to total charge
	
	totalcharge->SetBinContent(it/DeltatStep+1, sum);
	
	delete sigmah;
		
}
f.Close();	

totalcharge->SetStats(0);
totalcharge->SetXTitle("Time (s)");
totalcharge->SetYTitle("Charge (Coulomb)");
totalcharge->Draw();
//*/
}
